"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseEVMExternalStateProvider = void 0;
var crypto_rpc_1 = require("crypto-rpc");
var lodash_1 = __importDefault(require("lodash"));
var config_1 = __importDefault(require("../../../../config"));
var logger_1 = __importDefault(require("../../../../logger"));
var convert_1 = require("../../../../utils/convert");
var stats_1 = require("../../../../utils/stats");
var moralis_1 = __importDefault(require("../../external/providers/moralis"));
var apiStream_1 = require("../../external/streams/apiStream");
var nodeStream_1 = require("../../external/streams/nodeStream");
var internal_1 = require("../../internal/internal");
var transaction_1 = require("../models/transaction");
var csp_1 = require("./csp");
var provider_1 = require("./provider");
var BaseEVMExternalStateProvider = /** @class */ (function (_super) {
    __extends(BaseEVMExternalStateProvider, _super);
    function BaseEVMExternalStateProvider(chain) {
        if (chain === void 0) { chain = 'ETH'; }
        var _this = _super.call(this, chain) || this;
        _this.chain = chain;
        _this.config = config_1.default.chains[_this.chain];
        return _this;
    }
    BaseEVMExternalStateProvider.prototype.getWeb3 = function (network, params) {
        var _a, _b, _c, _d, _e, _f, _g;
        return __awaiter(this, void 0, void 0, function () {
            var _h, _j, rpc_1, e_1, idx, e_2_1, dataType, providerConfig, rpcConfig, rpc, rpcObj;
            var e_2, _k;
            return __generator(this, function (_l) {
                switch (_l.label) {
                    case 0:
                        _l.trys.push([0, 7, 8, 9]);
                        _h = __values(((_a = csp_1.BaseEVMStateProvider.rpcs[this.chain]) === null || _a === void 0 ? void 0 : _a[network]) || []), _j = _h.next();
                        _l.label = 1;
                    case 1:
                        if (!!_j.done) return [3 /*break*/, 6];
                        rpc_1 = _j.value;
                        if (!(0, provider_1.isValidProviderType)(params === null || params === void 0 ? void 0 : params.type, rpc_1.dataType)) {
                            return [3 /*break*/, 5];
                        }
                        _l.label = 2;
                    case 2:
                        _l.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, Promise.race([
                                rpc_1.web3.eth.getBlockNumber(),
                                new Promise(function (_, reject) { return setTimeout(reject, 5000); })
                            ])];
                    case 3:
                        _l.sent();
                        return [2 /*return*/, rpc_1]; // return the first applicable rpc that's responsive
                    case 4:
                        e_1 = _l.sent();
                        // try reconnecting
                        if (typeof ((_b = rpc_1.web3.currentProvider) === null || _b === void 0 ? void 0 : _b.disconnect) === 'function') {
                            (_d = (_c = rpc_1.web3.currentProvider) === null || _c === void 0 ? void 0 : _c.disconnect) === null || _d === void 0 ? void 0 : _d.call(_c);
                            (_f = (_e = rpc_1.web3.currentProvider) === null || _e === void 0 ? void 0 : _e.connect) === null || _f === void 0 ? void 0 : _f.call(_e);
                            if ((_g = rpc_1.web3.currentProvider) === null || _g === void 0 ? void 0 : _g.connected) {
                                return [2 /*return*/, rpc_1];
                            }
                        }
                        idx = csp_1.BaseEVMStateProvider.rpcs[this.chain][network].indexOf(rpc_1);
                        csp_1.BaseEVMStateProvider.rpcs[this.chain][network].splice(idx, 1);
                        return [3 /*break*/, 5];
                    case 5:
                        _j = _h.next();
                        return [3 /*break*/, 1];
                    case 6: return [3 /*break*/, 9];
                    case 7:
                        e_2_1 = _l.sent();
                        e_2 = { error: e_2_1 };
                        return [3 /*break*/, 9];
                    case 8:
                        try {
                            if (_j && !_j.done && (_k = _h.return)) _k.call(_h);
                        }
                        finally { if (e_2) throw e_2.error; }
                        return [7 /*endfinally*/];
                    case 9:
                        logger_1.default.info("Making a new connection for ".concat(this.chain, ":").concat(network));
                        dataType = params === null || params === void 0 ? void 0 : params.type;
                        providerConfig = (0, provider_1.getProvider)({ network: network, dataType: dataType, config: this.config });
                        rpcConfig = __assign(__assign({}, providerConfig), { chain: 'ETH', currencyConfig: {} });
                        rpc = new crypto_rpc_1.CryptoRpc(rpcConfig, {}).get('ETH');
                        rpcObj = { rpc: rpc, web3: rpc.web3, dataType: rpcConfig.dataType || 'combined' };
                        if (!csp_1.BaseEVMStateProvider.rpcs[this.chain]) {
                            csp_1.BaseEVMStateProvider.rpcs[this.chain] = {};
                        }
                        if (!csp_1.BaseEVMStateProvider.rpcs[this.chain][network]) {
                            csp_1.BaseEVMStateProvider.rpcs[this.chain][network] = [];
                        }
                        csp_1.BaseEVMStateProvider.rpcs[this.chain][network].push(rpcObj);
                        return [2 /*return*/, rpcObj];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.getChainId = function (_a) {
        var network = _a.network;
        return __awaiter(this, void 0, void 0, function () {
            var web3;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.getWeb3(network)];
                    case 1:
                        web3 = (_b.sent()).web3;
                        return [4 /*yield*/, web3.eth.getChainId()];
                    case 2: return [2 /*return*/, _b.sent()];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.getLocalTip = function (_a) {
        var chain = _a.chain, network = _a.network, _b = _a.includeTxs, includeTxs = _b === void 0 ? false : _b;
        return __awaiter(this, void 0, void 0, function () {
            var web3, block;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, this.getWeb3(network)];
                    case 1:
                        web3 = (_c.sent()).web3;
                        return [4 /*yield*/, web3.eth.getBlock('latest')];
                    case 2:
                        block = _c.sent();
                        return [2 /*return*/, ECSP.transformBlockData({ chain: chain, network: network, block: block, includeTxs: includeTxs })];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.getFee = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var network, _a, target, web3, latestBlock, feeHistory, gasPrices, length, i, whichQuartile, quartileMedian, feerate;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        network = params.network, _a = params.target, target = _a === void 0 ? 4 : _a;
                        return [4 /*yield*/, this.getWeb3(network, { type: 'historical' })];
                    case 1:
                        web3 = (_b.sent()).web3;
                        return [4 /*yield*/, web3.eth.getBlockNumber()];
                    case 2:
                        latestBlock = _b.sent();
                        return [4 /*yield*/, web3.eth.getFeeHistory(20 * 200, latestBlock, [25])];
                    case 3:
                        feeHistory = _b.sent();
                        gasPrices = [];
                        length = Math.min(feeHistory.baseFeePerGas.length, feeHistory.reward.length);
                        for (i = 0; i < length; i++) {
                            // Adds base fee with reward / priority fee to get total gas price in wei
                            // For pre-type2 blocks the gas prices are returned as rewards and zeroes are returned for the base fee per gas
                            gasPrices.push(BigInt(feeHistory.baseFeePerGas[i]) + BigInt(feeHistory.reward[i][0]));
                        }
                        // Sort descending with an appropriate BigInt comparator
                        gasPrices.sort(function (a, b) { return (a < b ? 1 : a > b ? -1 : 0); });
                        whichQuartile = Math.min(target, 4) || 1;
                        quartileMedian = stats_1.StatsUtil.getNthQuartileMedian(gasPrices, whichQuartile);
                        feerate = quartileMedian.toString();
                        // Fee returned in wei as a string
                        return [2 /*return*/, { feerate: feerate, blocks: target }];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.getBlocks = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var chain_1, network_1, query, web3_1, tip, tipHeight_1, blockTransform, batch_1, blockPromises, blockNumbers_1, _loop_1, i, err_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 4, , 5]);
                        chain_1 = params.chain, network_1 = params.network;
                        return [4 /*yield*/, this.getBlocksParams(params)];
                    case 1:
                        query = (_a.sent()).query;
                        return [4 /*yield*/, this.getWeb3(network_1, { type: 'historical' })];
                    case 2:
                        web3_1 = (_a.sent()).web3;
                        return [4 /*yield*/, this.getLocalTip(params)];
                    case 3:
                        tip = _a.sent();
                        tipHeight_1 = tip ? tip.height : 0;
                        blockTransform = function (block) { return __awaiter(_this, void 0, void 0, function () {
                            var confirmations, blockHeight, convertedBlock;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, block];
                                    case 1:
                                        block = _a.sent();
                                        confirmations = 0;
                                        blockHeight = block.height || block.number || 0;
                                        if (blockHeight >= 0) {
                                            confirmations = tipHeight_1 - blockHeight + 1;
                                        }
                                        convertedBlock = ECSP.transformBlockData({ chain: chain_1, network: network_1, block: block });
                                        return [2 /*return*/, __assign(__assign({}, convertedBlock), { confirmations: confirmations })];
                                }
                            });
                        }); };
                        batch_1 = new web3_1.eth.BatchRequest();
                        blockPromises = [];
                        blockNumbers_1 = lodash_1.default.range(query.startBlock, query.endBlock + 1);
                        _loop_1 = function (i) {
                            var blockPromise = new Promise(function (resolve, reject) {
                                batch_1.add(web3_1.eth.getBlock.request(blockNumbers_1[i], function (error, block) {
                                    if (error) {
                                        return reject(error);
                                    }
                                    return resolve(block);
                                }));
                            });
                            blockPromises.push(blockPromise);
                        };
                        // batch getBlock requests to reduce latency
                        for (i = 0; i < blockNumbers_1.length; i++) {
                            _loop_1(i);
                        }
                        ;
                        batch_1.execute();
                        return [2 /*return*/, Promise.all(blockPromises)
                                .then(blockPromises.map(blockTransform))
                                .catch(function (error) { return error; })];
                    case 4:
                        err_1 = _a.sent();
                        logger_1.default.error('Error getting blocks from historical node: %o', err_1.log || err_1);
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/, undefined];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.getTransaction = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var chain, network, txId, web3, tip, tipHeight, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 4, , 5]);
                        chain = params.chain, network = params.network, txId = params.txId;
                        if (typeof txId !== 'string' || !chain || !network) {
                            throw new Error('Missing required param');
                        }
                        return [4 /*yield*/, this.getWeb3(network, { type: 'historical' })];
                    case 1:
                        web3 = (_a.sent()).web3;
                        return [4 /*yield*/, this.getLocalTip(params)];
                    case 2:
                        tip = _a.sent();
                        tipHeight = tip ? tip.height : 0;
                        return [4 /*yield*/, this._getTransaction({ chain: chain, network: network, txId: txId, tipHeight: tipHeight, web3: web3 })];
                    case 3: return [2 /*return*/, _a.sent()];
                    case 4:
                        err_2 = _a.sent();
                        logger_1.default.error('Error getting transactions from historical node %o', err_2.log || err_2);
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/, undefined];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.prototype._getTransaction = function (_a) {
        var chain = _a.chain, network = _a.network, txId = _a.txId, tipHeight = _a.tipHeight, web3 = _a.web3;
        return __awaiter(this, void 0, void 0, function () {
            var tx, confirmations, _b, receipt, fee, tansformedTx, convertedTx;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, web3.eth.getTransaction(txId)];
                    case 1:
                        tx = _c.sent();
                        if (!tx) return [3 /*break*/, 4];
                        confirmations = 0;
                        if (tx.blockNumber && tx.blockNumber >= 0) {
                            confirmations = tipHeight - tx.blockNumber + 1;
                        }
                        _b = tx;
                        return [4 /*yield*/, this.getBlockTimestamp(tx.blockHash, { network: network })];
                    case 2:
                        _b.blockTime = _c.sent();
                        return [4 /*yield*/, web3.eth.getTransactionReceipt(txId)];
                    case 3:
                        receipt = _c.sent();
                        if (receipt) {
                            fee = receipt.gasUsed * parseInt(tx.gasPrice);
                            tx.receipt = receipt;
                            tx.fee = fee;
                        }
                        tansformedTx = ECSP.transformTransactionData({ tx: tx, network: network, chain: chain });
                        convertedTx = transaction_1.EVMTransactionStorage._apiTransform(tansformedTx, { object: true });
                        return [2 /*return*/, __assign(__assign({}, convertedTx), { confirmations: confirmations })];
                    case 4: return [2 /*return*/, undefined];
                }
            });
        });
    };
    // stream all transactions from a desired block
    BaseEVMExternalStateProvider.prototype.streamTransactions = function (params) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var chain, network, req, res, args, blockHash, blockHeight, tip, tipHeight_2, web3_2, block, getTransaction, txStream, result, err_3;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        chain = params.chain, network = params.network, req = params.req, res = params.res, args = params.args;
                        blockHash = args.blockHash, blockHeight = args.blockHeight;
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 6, , 7]);
                        if (blockHeight !== undefined) {
                            blockHeight = Number(blockHeight);
                        }
                        return [4 /*yield*/, this.getLocalTip(params)];
                    case 2:
                        tip = _b.sent();
                        tipHeight_2 = tip ? tip.height : 0;
                        return [4 /*yield*/, this.getWeb3(network, { type: 'historical' })];
                    case 3:
                        web3_2 = (_b.sent()).web3;
                        return [4 /*yield*/, web3_2.eth.getBlock(blockHash || blockHeight)];
                    case 4:
                        block = _b.sent();
                        getTransaction = (function (txId) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, this._getTransaction({ chain: chain, network: network, txId: txId, tipHeight: tipHeight_2, web3: web3_2 })];
                                    case 1: return [2 /*return*/, _a.sent()];
                                }
                            });
                        }); }).bind(this);
                        txStream = new nodeStream_1.NodeQueryStream((block === null || block === void 0 ? void 0 : block.transactions) || [], getTransaction, args);
                        return [4 /*yield*/, nodeStream_1.NodeQueryStream.onStream(txStream, req, res)];
                    case 5:
                        result = _b.sent();
                        if ((result === null || result === void 0 ? void 0 : result.success) === false) {
                            logger_1.default.error('Error mid-stream (streamTransactions): %o', ((_a = result.error) === null || _a === void 0 ? void 0 : _a.log) || result.error);
                        }
                        return [3 /*break*/, 7];
                    case 6:
                        err_3 = _b.sent();
                        logger_1.default.error('Error streaming transactions from historical node %o', err_3.log || err_3);
                        throw err_3;
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.streamAddressTransactions = function (params) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var req, res, args, chain, network, address, tokenAddress, result, chainId, tip, txStream, tokenTransfers, err_4;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        req = params.req, res = params.res, args = params.args, chain = params.chain, network = params.network, address = params.address;
                        tokenAddress = args.tokenAddress;
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 8, , 9]);
                        result = void 0;
                        return [4 /*yield*/, this.getChainId({ network: network })];
                    case 2:
                        chainId = _b.sent();
                        return [4 /*yield*/, this.getLocalTip(params)];
                    case 3:
                        tip = _b.sent();
                        args.tipHeight = tip ? tip.height : 0;
                        if (!!args.tokenAddress) return [3 /*break*/, 5];
                        txStream = moralis_1.default.streamTransactionsByAddress({ chainId: chainId, chain: chain, network: network, address: address, args: args });
                        return [4 /*yield*/, apiStream_1.ExternalApiStream.onStream(txStream, req, res)];
                    case 4:
                        result = _b.sent();
                        return [3 /*break*/, 7];
                    case 5:
                        tokenTransfers = moralis_1.default.streamERC20TransactionsByAddress({ chainId: chainId, chain: chain, network: network, address: address, tokenAddress: tokenAddress, args: args });
                        return [4 /*yield*/, apiStream_1.ExternalApiStream.onStream(tokenTransfers, req, res)];
                    case 6:
                        result = _b.sent();
                        _b.label = 7;
                    case 7:
                        if ((result === null || result === void 0 ? void 0 : result.success) === false) {
                            logger_1.default.error('Error mid-stream (streamAddressTransactions): %o', ((_a = result.error) === null || _a === void 0 ? void 0 : _a.log) || result.error);
                        }
                        return [3 /*break*/, 9];
                    case 8:
                        err_4 = _b.sent();
                        logger_1.default.error('Error streaming address transactions from external provider: %o', err_4.log || err_4);
                        throw err_4;
                    case 9: return [2 /*return*/];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.streamWalletTransactions = function (params) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var network, wallet, chain, req, res, args, chainId, tip, walletAddresses, mergedStream, txStreams, _mergedStream, i, result, err_5;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        network = params.network, wallet = params.wallet, chain = params.chain, req = params.req, res = params.res, args = params.args;
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 6, , 7]);
                        if (!(wallet === null || wallet === void 0 ? void 0 : wallet._id)) {
                            throw new Error('Missing wallet');
                        }
                        return [4 /*yield*/, this.getChainId({ network: network })];
                    case 2:
                        chainId = _b.sent();
                        return [4 /*yield*/, this.getLocalTip(params)];
                    case 3:
                        tip = _b.sent();
                        args.tipHeight = tip ? tip.height : 0;
                        return [4 /*yield*/, this.getWalletAddresses(wallet._id)];
                    case 4:
                        walletAddresses = (_b.sent()).map(function (addy) { return addy.address; });
                        mergedStream = new apiStream_1.MergedStream();
                        txStreams = [];
                        _mergedStream = apiStream_1.ExternalApiStream.onStream(mergedStream, req, res, { jsonl: true });
                        // Default to pulling only the first 10 transactions per address
                        for (i = 0; i < walletAddresses.length; i++) {
                            // args / query params are processed at the api provider level
                            txStreams.push(moralis_1.default.streamTransactionsByAddress({ chainId: chainId, chain: chain, network: network, address: walletAddresses[i], args: args }));
                        }
                        // Pipe all txStreams to the mergedStream
                        apiStream_1.ExternalApiStream.mergeStreams(txStreams, mergedStream);
                        return [4 /*yield*/, _mergedStream];
                    case 5:
                        result = _b.sent();
                        if ((result === null || result === void 0 ? void 0 : result.success) === false) {
                            logger_1.default.error('Error mid-stream (streamWalletTransactions): %o', ((_a = result.error) === null || _a === void 0 ? void 0 : _a.log) || result.error);
                        }
                        return [3 /*break*/, 7];
                    case 6:
                        err_5 = _b.sent();
                        logger_1.default.error('Error streaming wallet transactions from external provider: %o', err_5.log || err_5);
                        throw err_5;
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.getWalletBalanceAtTime = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var network, time, wallet, addresses, block, result, err_6;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        network = params.network, time = params.time, wallet = params.wallet;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 5, , 6]);
                        if (!(wallet === null || wallet === void 0 ? void 0 : wallet._id)) {
                            throw new Error('Missing wallet');
                        }
                        return [4 /*yield*/, this.getWalletAddresses(wallet._id)];
                    case 2:
                        addresses = (_a.sent()).map(function (addy) { return addy.address; });
                        return [4 /*yield*/, this.getBlockNumberByDate({ network: network, date: time })];
                    case 3:
                        block = _a.sent();
                        return [4 /*yield*/, this.getNativeBalanceByBlock({ network: network, block: block, addresses: addresses })];
                    case 4:
                        result = _a.sent();
                        return [2 /*return*/, { unconfirmed: 0, confirmed: result === null || result === void 0 ? void 0 : result.total_balance, balance: result === null || result === void 0 ? void 0 : result.total_balance }];
                    case 5:
                        err_6 = _a.sent();
                        logger_1.default.error('Error getting wallet balance at time from external provider %o', err_6.log || err_6);
                        throw err_6;
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.getBlockTimestamp = function (blockNumber, _a) {
        var network = _a.network;
        return __awaiter(this, void 0, void 0, function () {
            var web3, block;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.getWeb3(network)];
                    case 1:
                        web3 = (_b.sent()).web3;
                        return [4 /*yield*/, web3.eth.getBlock(blockNumber)];
                    case 2:
                        block = _b.sent();
                        return [2 /*return*/, (0, convert_1.unixToDate)(block.timestamp)];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.getBlocksParams = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var chain, network, sinceBlock, blockId, _a, args, startDate, endDate, date, since, direction, paging, _b, limit, _c, sort, options, query, height, height, _d, _e, _f, _g, firstDate, nextDate, _h, _j, _k, _l, blockNum, blockNum, tip, tipHeight, endBlock, startBlock, b;
            return __generator(this, function (_m) {
                switch (_m.label) {
                    case 0:
                        chain = params.chain, network = params.network, sinceBlock = params.sinceBlock, blockId = params.blockId, _a = params.args, args = _a === void 0 ? {} : _a;
                        startDate = args.startDate, endDate = args.endDate, date = args.date, since = args.since, direction = args.direction, paging = args.paging;
                        _b = args.limit, limit = _b === void 0 ? 10 : _b, _c = args.sort, sort = _c === void 0 ? { height: -1 } : _c;
                        options = { limit: limit, sort: sort, since: since, direction: direction, paging: paging };
                        query = { startBlock: 0, endBlock: 0 };
                        if (!chain || !network) {
                            throw new Error('Missing required param');
                        }
                        if (blockId) {
                            if (blockId.length >= 64) {
                                query['block'] = blockId;
                            }
                            else {
                                height = parseInt(blockId, 10);
                                if (Number.isNaN(height) || height.toString(10) !== blockId) {
                                    throw new Error('invalid block id provided');
                                }
                                query['height'] = height;
                            }
                        }
                        if (sinceBlock) {
                            height = Number(sinceBlock);
                            if (Number.isNaN(height) || height.toString(10) !== sinceBlock) {
                                throw new Error('invalid block id provided');
                            }
                            query['height'] = height;
                        }
                        if (!startDate) return [3 /*break*/, 2];
                        _d = query;
                        _e = 'startDateBlock';
                        return [4 /*yield*/, this.getBlockNumberByDate({ date: startDate, network: network })];
                    case 1:
                        _d[_e] = _m.sent();
                        _m.label = 2;
                    case 2:
                        if (!endDate) return [3 /*break*/, 4];
                        _f = query;
                        _g = 'endDateBlock';
                        return [4 /*yield*/, this.getBlockNumberByDate({ date: endDate, network: network })];
                    case 3:
                        _f[_g] = _m.sent();
                        _m.label = 4;
                    case 4:
                        if (!date) return [3 /*break*/, 7];
                        firstDate = new Date(date);
                        nextDate = new Date(date);
                        nextDate.setDate(nextDate.getDate() + 1);
                        _h = query;
                        _j = 'startDateBlock';
                        return [4 /*yield*/, this.getBlockNumberByDate({ date: firstDate, network: network })];
                    case 5:
                        _h[_j] = _m.sent();
                        _k = query;
                        _l = 'endDateBlock';
                        return [4 /*yield*/, this.getBlockNumberByDate({ date: nextDate, network: network })];
                    case 6:
                        _k[_l] = _m.sent();
                        _m.label = 7;
                    case 7:
                        if (!((query === null || query === void 0 ? void 0 : query.block) && (query === null || query === void 0 ? void 0 : query.height))) return [3 /*break*/, 9];
                        return [4 /*yield*/, this.getBlockNumberByBlockId({ blockId: query.block, network: network })];
                    case 8:
                        blockNum = _m.sent();
                        if (!blockNum) {
                            throw new Error("Could not get block ".concat(query.block));
                        }
                        query.startBlock = blockNum;
                        query.endBlock = blockNum + query.height;
                        _m.label = 9;
                    case 9:
                        if (!(!(query === null || query === void 0 ? void 0 : query.block) && (query === null || query === void 0 ? void 0 : query.height))) return [3 /*break*/, 11];
                        return [4 /*yield*/, this.getBlockNumberByBlockId({ blockId: query.height, network: network })];
                    case 10:
                        blockNum = _m.sent();
                        if (!blockNum) {
                            throw new Error("Could not get block ".concat(query.block));
                        }
                        query.startBlock = blockNum;
                        _m.label = 11;
                    case 11:
                        if (query === null || query === void 0 ? void 0 : query.startDateBlock) {
                            query.startBlock = query.startDateBlock;
                        }
                        if (query === null || query === void 0 ? void 0 : query.endDateBlock) {
                            query.endBlock = query.endDateBlock;
                        }
                        return [4 /*yield*/, this.getLocalTip(params)];
                    case 12:
                        tip = _m.sent();
                        tipHeight = tip ? tip.height : 0;
                        endBlock = query.endBlock || tipHeight;
                        startBlock = query.startBlock || endBlock - 1;
                        if (limit && limit > 0 && (endBlock - startBlock) > limit) {
                            endBlock = startBlock + limit;
                        }
                        if (sort === -1) {
                            b = startBlock;
                            startBlock = endBlock;
                            endBlock = b;
                        }
                        // { limit, sort, since, direction, paging };
                        return [2 /*return*/, { query: query, options: options }];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.getBlockNumberByDate = function (_a) {
        var date = _a.date, network = _a.network;
        return __awaiter(this, void 0, void 0, function () {
            var chainId, res, block;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.getChainId({ network: network })];
                    case 1:
                        chainId = _b.sent();
                        return [4 /*yield*/, moralis_1.default.getBlockByDate({ chainId: chainId, date: date })];
                    case 2:
                        res = _b.sent();
                        block = JSON.parse(res.body);
                        return [2 /*return*/, block.number ? Number(block.number) : undefined];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.getBlockNumberByBlockId = function (_a) {
        var blockId = _a.blockId, network = _a.network;
        return __awaiter(this, void 0, void 0, function () {
            var chainId, res, block;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.getChainId({ network: network })];
                    case 1:
                        chainId = _b.sent();
                        return [4 /*yield*/, moralis_1.default.getBlockByHash({ chainId: chainId, blockId: blockId })];
                    case 2:
                        res = _b.sent();
                        block = JSON.parse(res.body);
                        return [2 /*return*/, block.number ? Number(block.number) : undefined];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.getNativeBalanceByBlock = function (_a) {
        var network = _a.network, block = _a.block, addresses = _a.addresses;
        return __awaiter(this, void 0, void 0, function () {
            var chainId, res;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.getChainId({ network: network })];
                    case 1:
                        chainId = _b.sent();
                        return [4 /*yield*/, moralis_1.default.getNativeBalanceByBlock({ chainId: chainId, block: block, addresses: addresses })];
                    case 2:
                        res = _b.sent();
                        return [2 /*return*/, JSON.parse(res.body)];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.transformBlockData = function (_a) {
        var chain = _a.chain, network = _a.network, block = _a.block, _b = _a.includeTxs, includeTxs = _b === void 0 ? false : _b;
        var data = {
            chain: chain,
            network: network,
            height: block.number,
            hash: block.hash,
            time: (0, convert_1.unixToDate)(block.timestamp),
            timeNormalized: (0, convert_1.unixToDate)(block.timestamp),
            previousBlockHash: block.parentHash,
            nextBlockHash: '',
            transactionCount: block.transactions.length,
            size: block.size,
            reward: 5,
            processed: true,
            nonce: block.nonce,
            difficulty: block.difficulty,
            gasUsed: block.gasUsed,
            gasLimit: block.gasLimit,
            baseFeePerGas: block.baseFeePerGas // BigNumber
        }; // IEVMBlock
        if (includeTxs) {
            data.transactions = block.transactions;
        }
        return data;
    };
    BaseEVMExternalStateProvider.transformTransactionData = function (_a) {
        var chain = _a.chain, network = _a.network, tx = _a.tx;
        return {
            txid: tx.hash,
            chain: chain,
            network: network,
            blockHeight: tx.blockNumber || tx.block_number,
            blockHash: tx.blockHash || tx.block_hash,
            blockTime: tx.blockTime || tx.block_timestamp,
            blockTimeNormalized: tx.blockTimeNormalized,
            fee: tx.fee,
            value: tx.value,
            gasLimit: tx.gasLimit || tx.gas,
            gasPrice: tx.gasPrice || tx.gas_price,
            nonce: tx.nonce,
            to: tx.to || tx.to_address,
            from: tx.from || tx.from_address,
            data: tx.data,
            effects: tx.effects,
        };
    };
    return BaseEVMExternalStateProvider;
}(internal_1.InternalStateProvider));
exports.BaseEVMExternalStateProvider = BaseEVMExternalStateProvider;
var ECSP = BaseEVMExternalStateProvider;
//# sourceMappingURL=ecsp.js.map