"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a, _b;
Object.defineProperty(exports, "__esModule", { value: true });
var request = require("request");
var config_1 = __importDefault(require("../../../../config"));
var check_1 = require("../../../../utils/check");
var transaction_1 = require("../../evm/models/transaction");
var apiStream_1 = require("../streams/apiStream");
var baseUrl = 'https://deep-index.moralis.io/api/v2.2';
var headers = {
    'Content-Type': 'application/json',
    'X-API-Key': (_b = (_a = config_1.default.externalProviders) === null || _a === void 0 ? void 0 : _a.moralis) === null || _b === void 0 ? void 0 : _b.apiKey,
};
var getBlockByDate = function (_a) {
    var chainId = _a.chainId, date = _a.date;
    return __awaiter(void 0, void 0, void 0, function () {
        var query, queryStr;
        return __generator(this, function (_b) {
            if (!date || !(0, check_1.isDateValid)(date)) {
                throw new Error('Invalid date');
            }
            if (!chainId) {
                throw new Error('Invalid chainId');
            }
            query = transformQueryParams({ chainId: formatChainId(chainId), args: { date: date } });
            queryStr = buildQueryString(query);
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    request({
                        method: 'GET',
                        url: "".concat(baseUrl, "/dateToBlock").concat(queryStr),
                        headers: headers
                    }, function (err, data) {
                        if (err) {
                            return reject(err);
                        }
                        return resolve(data);
                    });
                })];
        });
    });
};
var getBlockByHash = function (_a) {
    var chainId = _a.chainId, blockId = _a.blockId;
    return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_b) {
            if (!blockId) {
                throw new Error('Invalid block number or hash string');
            }
            if (!chainId) {
                throw new Error('Invalid chainId');
            }
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    request({
                        method: 'GET',
                        url: "".concat(baseUrl, "/block/").concat(blockId, "?chain=").concat(chainId),
                        headers: headers
                    }, function (err, data) {
                        if (err) {
                            return reject(err);
                        }
                        return resolve(data);
                    });
                })];
        });
    });
};
var getNativeBalanceByBlock = function (_a) {
    var chainId = _a.chainId, block = _a.block, addresses = _a.addresses;
    return __awaiter(void 0, void 0, void 0, function () {
        var queryStr;
        return __generator(this, function (_b) {
            if (!block) {
                throw new Error('Invalid block number or hash string');
            }
            queryStr = buildQueryString({
                chain: chainId,
                wallet_address: addresses
            });
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    request({
                        method: 'GET',
                        url: "".concat(baseUrl, "/wallets/balances").concat(queryStr),
                        headers: headers
                    }, function (err, data) {
                        if (err) {
                            return reject(err);
                        }
                        return resolve(data);
                    });
                })];
        });
    });
};
var streamTransactionsByAddress = function (_a) {
    var chainId = _a.chainId, chain = _a.chain, network = _a.network, address = _a.address, args = _a.args;
    if (!address) {
        throw new Error('Missing address');
    }
    if (!chainId) {
        throw new Error('Invalid chainId');
    }
    var query = transformQueryParams({ chainId: chainId, args: args }); // throws if no chain or network
    var queryStr = buildQueryString(__assign(__assign({}, query), { order: args.order || 'DESC', limit: (args === null || args === void 0 ? void 0 : args.page_limit) || 10, nft_metadata: false, include_input_data: true, include_internal_transactions: true }));
    args.transform = function (tx) {
        var _tx = transformTransaction(__assign({ chain: chain, network: network }, tx));
        var confirmations = calculateConfirmations(tx, args.tipHeight);
        return transaction_1.EVMTransactionStorage._apiTransform(__assign(__assign({}, _tx), { confirmations: confirmations }), { object: true });
    };
    return new apiStream_1.ExternalApiStream("".concat(baseUrl, "/wallets/").concat(address, "/history").concat(queryStr), headers, args);
};
var streamERC20TransactionsByAddress = function (_a) {
    var chainId = _a.chainId, chain = _a.chain, network = _a.network, address = _a.address, tokenAddress = _a.tokenAddress, args = _a.args;
    if (!address) {
        throw new Error('Missing address');
    }
    if (!tokenAddress) {
        throw new Error('Missing token address');
    }
    if (!chainId) {
        throw new Error('Invalid chainId');
    }
    var queryTransform = transformQueryParams({ chainId: chainId, args: args }); // throws if no chain or network
    var queryStr = buildQueryString(__assign(__assign({}, queryTransform), { order: args.order || 'DESC', limit: (args === null || args === void 0 ? void 0 : args.page_limit) || 10, contract_addresses: [tokenAddress] }));
    args.transform = function (tx) {
        var _tx = transformTokenTransfer(__assign({ chain: chain, network: network }, tx));
        var confirmations = calculateConfirmations(tx, args.tipHeight);
        return transaction_1.EVMTransactionStorage._apiTransform(__assign(__assign({}, _tx), { confirmations: confirmations }), { object: true });
    };
    return new apiStream_1.ExternalApiStream("".concat(baseUrl, "/").concat(address, "/erc20/transfers").concat(queryStr), headers, args);
};
var transformTransaction = function (tx) {
    return {
        chain: tx.chain,
        network: tx.network,
        txid: tx.hash,
        blockHeight: Number(tx.block_number),
        blockHash: tx.block_hash,
        blockTime: new Date(tx.block_timestamp),
        blockTimeNormalized: new Date(tx.block_timestamp),
        value: tx.value,
        gasLimit: tx.gas,
        gasPrice: tx.gas_price,
        fee: Number(tx.receipt_gas_used) * Number(tx.gas_price),
        nonce: tx.nonce,
        to: tx.to_address,
        from: tx.from_address,
        data: tx.input,
        internal: tx === null || tx === void 0 ? void 0 : tx.internal_transactions.map(function (t) { return transformInternalTransaction(t); }),
        effects: tx.effects,
    };
};
var transformInternalTransaction = function (tx) {
    var _a, _b;
    return {
        action: {
            callType: (_a = tx.type) === null || _a === void 0 ? void 0 : _a.toLowerCase(),
            from: tx.from,
            gas: tx.gas,
            input: tx.input,
            to: tx.to,
            value: tx.value,
        },
        blockHash: tx.block_hash,
        blockNumber: Number(tx.block_number),
        error: tx.error,
        result: {
            gasUsed: tx.gas_used,
            output: tx.output
        },
        subtraces: tx.subtraces,
        traceAddress: tx.traceAddress || [],
        transactionHash: tx.transaction_hash,
        transactionPosition: tx.transactionPosition || 0,
        type: (_b = tx.type) === null || _b === void 0 ? void 0 : _b.toLowerCase()
    };
};
var transformTokenTransfer = function (transfer) {
    var _transfer = transformTransaction(transfer);
    return __assign(__assign({}, _transfer), { transactionHash: transfer.transaction_hash, transactionIndex: transfer.transaction_index, contractAddress: transfer.contract_address, name: transfer.token_name });
};
var transformQueryParams = function (params) {
    var chainId = params.chainId, args = params.args;
    var query = {
        chain: formatChainId(chainId),
    };
    if (args) {
        if (args.startBlock || args.endBlock) {
            if (args.startBlock) {
                query.from_block = Number(args.startBlock);
            }
            if (args.endBlock) {
                query.to_block = Number(args.endBlock);
            }
        }
        else {
            if (args.startDate) {
                query.from_date = args.startDate;
            }
            if (args.endDate) {
                query.to_date = args.endDate;
            }
        }
        if (args.direction) {
            query.order = Number(args.direction) > 0 ? 'ASC' : 'DESC';
        }
        if (args.date) {
            query.date = new Date(args.date).getTime();
        }
    }
    return query;
};
var calculateConfirmations = function (tx, tip) {
    var confirmations = 0;
    if (tx.blockHeight && tx.blockHeight >= 0) {
        confirmations = tip - tx.blockHeight + 1;
    }
    return confirmations;
};
var buildQueryString = function (params) {
    var e_1, _a;
    var query = [];
    try {
        for (var _b = __values(Object.entries(params)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var _d = __read(_c.value, 2), key = _d[0], value = _d[1];
            if (Array.isArray(value)) {
                for (var i = 0; i < value.length; i++) {
                    // add array values in the form of key[i]=value
                    if (value[i] != null)
                        query.push("".concat(key, "%5B").concat(i, "%5D=").concat(value[i]));
                }
            }
            else if (value != null) {
                query.push("".concat(key, "=").concat(value));
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return query.length ? "?".concat(query.join('&')) : '';
};
var formatChainId = function (chainId) {
    return '0x' + parseInt(chainId).toString(16);
};
var MoralisAPI = {
    getBlockByDate: getBlockByDate,
    getBlockByHash: getBlockByHash,
    getNativeBalanceByBlock: getNativeBalanceByBlock,
    streamTransactionsByAddress: streamTransactionsByAddress,
    streamERC20TransactionsByAddress: streamERC20TransactionsByAddress
};
exports.default = MoralisAPI;
//# sourceMappingURL=moralis.js.map